unit engine;

interface
uses SysUtils,Windows,GLScene, GLVectorFileObjects, GLObjects, GLCadencer,
  GLWin32Viewer, GLMisc, Math,GLTexture, jpeg, Graphics, GLThorFX,GLFireFX,Geometry,VectorTypes,keyboard,inifiles,option;

type TCustomShip=class
private
  fmodel:TFreeForm;
  dummy:TDummyCube;
  speed,maxspeed,accel:single;
  numengine:integer;
  ksrot:Single;
  maxsrot:Single;
  Rotated:Boolean;
  pits,turs,rols:single;
  kpitch,kturn,kroll:single;
  distance:single;
  fengine:Array[1..10] of TDummyCube;
  flaser:Array[1..10] of TCylinder;
  fenginesprite:Array[1..10] of TSprite;
  flight:Array[1..10] of TGLLightSource;
  ffire:Array[1..10] of TGLFireFXManager;
  fcad:TGLCadencer;
  IntervalK:Word;
  Acceled:Boolean;
public
  property target:TDummyCube read dummy write dummy;
  procedure Rotate(pitch,turn,roll:single);
  procedure Move;
  procedure Life;
  procedure Stop;
  procedure Fire(TargetObj:TGLBaseSceneObject);
  constructor Create(path:String;cadencer:TGLCadencer);
end;

  type TShip=class(TCustomShip)
  private
    fcamera:TGLCamera;
    Pricel:TSprite;
  public
    property camera:TGLCamera read fcamera write fcamera;
    procedure Rotate(pitch,turn,roll:single);
    procedure Life;
    constructor Create(path:String;cadencer:TGLCadencer);
  end;

  type TAIShip=class(TCustomShip)
  private
    kAttack: single;
    kDrive: single;
    kMoral: single;
    kAvoid: single;
    kKam: single;
    IQ: single;
    kShab: single;
  public
    procedure Brain(Target:TCustomShip);
  end;

implementation
//TCustomShip-------------------------------------------------
constructor TCustomShip.Create(path:String;cadencer:TGLCadencer);
var f:text; s,s2:String; v,m:Single; i,n:Integer;
var FX:TGLBFireFX;
inif,inim:TMemIniFile;
begin
  maxspeed:=0.05; speed:=0;
  pits:=0;turs:=0;rols:=0;
  ksrot:=0.07;
  maxsrot:=3;
  inim:=TMemIniFile.Create(path);
  dummy:=TDummyCube(cadencer.Scene.Objects.AddNewChild(TDummyCube));
  maxspeed:=inim.ReadFloat('General','maxspeed',0.05);
  kroll:=inim.ReadFloat('General','rollspeed',3);
  kturn:=inim.ReadFloat('General','turnspeed',3);
  kpitch:=inim.ReadFloat('General','pitchspeed',3);
  accel:=inim.ReadFloat('General','acceleration',0.01);
  fcad:=cadencer;
  fmodel:=TFreeForm(dummy.AddNewChild(TFreeForm));
  fmodel.LoadFromFile('models\'+inim.ReadString('General','type','')+'\'+inim.ReadString('General','name','')+'\'+inim.ReadString('General','model',''));
  fmodel.Material.Texture.Image.LoadFromFile('images\textures\ships\'+inim.ReadString('General','texture',''));
  fmodel.Material.Texture.Disabled:=False;
  fmodel.Material.Texture.TextureMode:=tmModulate;
  s2:=inim.ReadString('General','fire','');
  fmodel.Scale.X:=inim.ReadFloat('General','scale',0.01);
  fmodel.Scale.Y:=inim.ReadFloat('General','scale',0.01);;
  fmodel.Scale.Z:=inim.ReadFloat('General','scale',0.01);;
  fmodel.Position.Y:=-0.4;
  fmodel.Pitch(90);
  AssignFile(f,'data\engine\'+inim.ReadString('General','engine','')+'.eng');
  Reset(f);
  readln(f,n);
  readln(f,m);
  readln(f,s); numengine:=n;
    for i:=1 to n do begin
      //-----------
      if MainOption.Fire then begin
        inif:=TMemIniFile.Create('data/pfx/fire/'+s2+'.ini');
        IntervalK:=inif.ReadInteger('General','IntervalK',2000);
        fengine[i]:=TDummyCube(dummy.AddNewChild(TDummyCube));
        ffire[i]:=TGLFireFXManager.Create(fcad.Scene);
        ffire[i].Reference:=fengine[i];
        with ffire[i] do begin
          cadencer:=TGLCadencer(fcad);
          firedensity:=inif.ReadFloat('General','density',0.0);
          fireradius:=inif.ReadFloat('General','radius',0.0);
          firedir.X:=0;firedir.Y:=0;firedir.Z:=0;
          MaxParticles:=inif.ReadInteger('General','maxparticles',0);
          ParticleInterval:=inif.ReadFloat('General','interval',0);
          ParticleLife:=inif.ReadInteger('General','life',1);
          ParticleSize:=inif.ReadFloat('General','size',1);
          InnerColor.Red:=inif.ReadFloat('InnerColor','Red',0);
          InnerColor.Blue:=inif.ReadFloat('InnerColor','Blue',0);
          InnerColor.Green:=inif.ReadFloat('InnerColor','Green',0);
          OuterColor.Red:=inif.ReadFloat('InnerColor','Red',0);
          OuterColor.Blue:=inif.ReadFloat('InnerColor','Blue',0);
          OuterColor.Green:=inif.ReadFloat('InnerColor','Green',0);
          InitialDir.X:=0;InitialDir.Y:=0;InitialDir.Z:=0.2;
        end;
      inif.Free;
      FX:=TGLBFireFX.Create(fengine[i].Effects);
      FX.Manager:=ffire[i];
      end;
      //-----------  
      if MainOption.FireLight then begin
        inif:=TMemIniFile.Create('data/pfx/fire/'+s2+'.ini');
        flight[i]:=TGLLightSource(dummy.AddNewChild(TGLLightSource));
        flight[i].Diffuse.Blue:=inif.ReadFloat('InnerColor','Blue',0);
        flight[i].Diffuse.Green:=inif.ReadFloat('InnerColor','Green',0);
        flight[i].Diffuse.Red:=inif.ReadFloat('InnerColor','Red',0);
        flight[i].LightStyle:=lsOmni;
        inif.Free;
      end;
      //-----------
      if MainOption.Sprite then begin
        fenginesprite[i]:=TSprite(dummy.AddNewChild(TSprite));
        Randomize;
        fenginesprite[i].AlphaChannel:=Random(10000)/Random(4000);
        fenginesprite[i].Scale.X:=m;fenginesprite[i].Scale.Y:=m;fenginesprite[i].Scale.Z:=m;
        fenginesprite[i].Material.Texture.Image.LoadFromFile(s);
        fenginesprite[i].Material.Texture.Disabled:=false;
        fenginesprite[i].Material.BlendingMode:=bmAdditive;
        fenginesprite[i].Material.Texture.TextureMode:=tmReplace;
        fenginesprite[i].Material.Texture.TextureWrap:=twNone;
      end;
      read(f,v);
      if MainOption.Fire then fengine[i].Translate(v,0,0);
      if MainOption.Sprite then fenginesprite[i].Translate(v,0,0);
      if MainOption.FireLight then flight[i].Translate(v,0,0);
      read(f,v);
      if MainOption.Fire then fengine[i].Translate(0,v,0);
      if MainOption.Sprite then fenginesprite[i].Translate(0,v,0);
      if MainOption.FireLight then flight[i].Translate(v,0,0);
      read(f,v);
      if MainOption.Fire then fengine[i].Translate(0,0,v);
      if MainOption.Sprite then fenginesprite[i].Translate(0,0,v);
      if MainOption.FireLight then flight[i].Translate(v,0,0);
    end;
  CloseFile(f);
  end;

  procedure TCustomShip.Rotate(pitch,turn,roll:single);
  begin
    pits:=pits+pitch;
    turs:=turs+turn;
    rols:=rols+roll;
    Rotated:=True;
  end;

  procedure TCustomShip.Move;
  begin
    if speed<maxspeed then speed:=speed+accel;
    Acceled:=True;
  end;

  procedure TCustomShip.Stop;
  begin
    if speed>0 then begin speed:=speed-accel*2; if speed<0 then speed:=0; end;
    Acceled:=True;
  end;
  procedure TCustomShip.Life;
  var i:Byte;Vec:TVector4f; RightVector: TAffineVector; Up, Dir: TAffineVector;
  begin
    if(pits>maxsrot)or(pits<-maxsrot) then pits:=sign(pits)*maxsrot;
    if(turs>maxsrot)or(turs<-maxsrot) then turs:=sign(turs)*maxsrot;
    if(rols>maxsrot)or(rols<-maxsrot) then rols:=sign(rols)*maxsrot;
    dummy.Pitch(pits*fcad.Delta*10);
    dummy.Turn(turs*fcad.Delta*10);
    dummy.Roll(rols*fcad.Delta*10);
    if pits>0 then begin pits:=pits-ksrot; if pits<0 then pits:=0; end;
    if rols>0 then begin rols:=rols-ksrot; if rols<0 then rols:=0; end;
    if turs>0 then begin turs:=turs-ksrot; if turs<0 then turs:=0; end;
    if pits<0 then begin pits:=pits+ksrot; if pits>0 then pits:=0; end;
    if rols<0 then begin rols:=rols+ksrot; if rols>0 then rols:=0; end;
    if turs<0 then begin turs:=turs+ksrot; if turs>0 then turs:=0; end;
    if MainOption.Fire then begin
      if Rotated then begin
        SetVector(Up, dummy.Up.AsVector);
        SetVector(Dir, dummy.Direction.AsVector);
        VectorCrossProduct(Dir, Up, RightVector);
        MakeVector(vec,rightvector);
        ScaleVector(vec,0.2);
        NegateVector(vec);
      end;
      for i:=1 to numengine do begin
        ffire[i].Disabled:=not Acceled;
        ffire[i].ParticleInterval:=1/((speed+maxspeed/500)*IntervalK);
        if Rotated then ffire[i].InitialDir.AsVector:=vec;
      end;
    end;
    Rotated:=False;
    if speed>0 then begin speed:=speed-accel/2; Acceled:=True; if speed<0 then speed:=0; end;
    dummy.Slide(speed*100*fcad.Delta);
//    fcad.Scene.Objects.FindChild('Star',False).Position:=dummy.Position;
    if Assigned(flaser[1]) then flaser[1].Slide(0.1);
  end;
  procedure TCustomShip.Fire(TargetObj:TGLBaseSceneObject);
  begin
    if Assigned(flaser[1]) then flaser[1].Destroy;
    flaser[1]:=TCylinder(fcad.Scene.Objects.AddNewChild(TCylinder));
    with flaser[1] do begin
      BottomRadius:=0.05;
      TopRadius:=0.05;
      RollAngle:=dummy.RollAngle;
      TurnAngle:=dummy.TurnAngle;
      PitchAngle:=dummy.PitchAngle;
      Position:=dummy.Position;
      //Direction:=TargetObj.Position;
      Height:=2;
    end;
  end;

//TShip-------------------------------------------------

    constructor TShip.Create(path:String;cadencer:TGLCadencer);
  begin
      inherited;
      fcamera:=TGLCamera(dummy.AddNewChild(TGLCamera));
    Pricel:=TSprite(dummy.AddNewChild(TSprite));
    with Pricel.Material do begin
       Texture.Image.LoadFromFile('images/sprites/ships/pricel.bmp');
       BlendingMode:=bmAdditive;
       Texture.Enabled:=True;
    end;
    Pricel.Scale.Scale(0.3);
    with fcamera do begin
      Position.X:=2;
      Position.Y:=-0.3;
      DepthOfView:=MainOption.DepthView;
      CameraStyle:=csPerspective;
      FocalLength:=100;
      SceneScale:=0.5;
      Direction.Z:=-1;
      Turn(-90);
      Pitch(10);
      //TGLLightSource(AddnewChild(TGLLightSource)).ConstAttenuation:=2;
    end;
  end;

  procedure TShip.Rotate(pitch,turn,roll:single);
  begin
    inherited;
  end;
  procedure TShip.Life;
  var deltatime:double;
  begin
    inherited;
    // Rotate  30*deltatime   
    if isKeyDown(vk_up) then Rotate(0,0,kroll);
    if isKeyDown(vk_down) then Rotate(0,0,-kroll);
    if isKeyDown(vk_left) then Rotate(kpitch,0,0);
    if isKeyDown(vk_right) then Rotate(-kpitch,0,0);
//    if isKeyDown(33) then fcamera.MoveObjectAround(fmodel,kpitch/3,0);
//    if isKeyDown(34) then fcamera.MoveObjectAround(fmodel,-kpitch/3,0);
    if isKeyDown(vk_insert) then Move else Acceled:=False;
    if isKeyDown(vk_delete) then Stop;
    if distance<speed*40 then begin distance:=distance+speed/2; fcamera.Move(-speed/2); fcamera.Lift(speed/10); end else begin
     fcamera.Move(speed/2); fcamera.Lift(-speed/10); distance:=distance-speed/2;
    end;
  end;

//TAIShip-------------------------------------------------
  procedure TAIShip.Brain(Target:TCustomShip);
  var Vect:TVector4f;
  begin
    if dummy.DistanceTo(Target.dummy)>10 then begin Stop; exit; end;
    dummy.Direction:=Target.dummy.Position;
    dummy.Direction.Rotate(YVector,-90);
    Move;
//    Life;
//    if(dummy.Position.X>Target.dummy.Position.X) then dummy.Position.X:=dummy.Position.X-0.01 else dummy.Position.X:=dummy.Position.X+0.01;
//    if(dummy.Position.Y>Target.dummy.Position.Y) then dummy.Position.Y:=dummy.Position.Y-0.01 else dummy.Position.Y:=dummy.Position.Y+0.01;
//    if(dummy.Position.Z>Target.dummy.Position.Z) then dummy.Position.Z:=dummy.Position.Z-0.01 else dummy.Position.z:=dummy.Position.Z+0.01;
    //MakeVector(Vect,Target.dummy.Position.X-dummy.Position.X,Target.dummy.Position.Y-dummy.Position.Y,Target.dummy.Position.Z-dummy.Position.Z);
  end;

end.
