unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLCadencer, GLScene, GLWin32Viewer, GLMisc, engine, GLObjects,
  GLThorFX, AsyncTimer, GLHUDObjects, GLFireFX, keyboard, planet, option, GLzBuffer,
  GLCollision, GLVectorFileObjects, GLSkydome;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLCadencer1: TGLCadencer;
    AsyncTimer1: TAsyncTimer;
    GLLightSource1: TGLLightSource;
    Sprite1: TSprite;
    GLCamera2: TGLCamera;
    GLMemoryViewer1: TGLMemoryViewer;
    procedure FormCreate(Sender: TObject);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure AsyncTimer1Timer(Sender: TObject);
    procedure GLSceneViewer1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Ship:TShip;
  Plan:TPlanet;
  Asteroid:TAsteroid;
  AIShip:TAIShip;
  Star:TSphere;
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var i:Integer;
begin
  LoadOption;
  GLSceneViewer1.Buffer.AntiAliasing:=MainOption.AntiAliasing;
  GLSceneViewer1.Buffer.ColorDepth:=MainOption.ColorDepth;
  GLSceneViewer1.Buffer.DepthPrecision:=MainOption.DepthPrecision;
  GLSceneViewer1.Buffer.ShadeModel:=MainOption.ShadeModel;
  star:=TSphere(GLScene1.Objects.AddNewChild(TSphere));
  star.Material.Texture.Image.LoadFromFile('stars.jpg');
  star.Material.Texture.Enabled:=True;
  star.Radius:=MainOption.DepthView;
  star.NormalDirection:=ndInSide;
  star.Sorted:=False;
  Plan:=TPlanet.Create('data\planets\planet1.ini',GLCadencer1);
  AIShip:=TAIShip.Create('data\ships\storm.ini',GLCadencer1);
  Ship:=TShip.Create('data\ships\shark.ini',GLCadencer1);
  Asteroid:=TAsteroid.Create('data\asteroids\asteroid1.ini',GLCadencer1);
  GLSceneViewer1.Camera:=Ship.camera;
  AIShip.Life;
end;

procedure TForm1.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
  if not Assigned(Ship) then exit;
  AIShip.Brain(Ship);
  Ship.Life;
  Plan.Life;
  Asteroid.Life;
  AIShip.Life;
  star.Position:=ship.target.Position;
end;

procedure TForm1.AsyncTimer1Timer(Sender: TObject);
begin
  Caption:=Format('%.2f FPS', [GLSceneViewer1.FramesPerSecond]);
  GLSceneViewer1.ResetPerformanceMonitor;
end;

procedure TForm1.GLSceneViewer1Click(Sender: TObject);
begin
  Ship.Fire(Plan.Model);
end;

end.
