unit option;

interface
uses inifiles, GLScene, GLContext;
type TOption=record
  Fire:Boolean;
  Sprite:Boolean;
  FireLight:Boolean;
  Stack:Byte;
  Slice:Byte;
  AntiAliasing:TGLAntiAliasing;
  ColorDepth:TGLColorDepth;
  DoubleBuffer:Boolean;
  StrencilBuffer:Boolean;
  RenderToWindow:Boolean;
  Stereo:Boolean;
  DestinationAlpha:Boolean;
  NoColorBuffer:Boolean;
  DepthPrecision:TGLDepthPrecision;
  ShadeModel:TGLShadeModel;
  DepthView:Word;
end;
procedure LoadOption;
var MainOption:TOption;
implementation

procedure LoadOption;
var optini:TMemIniFile;
begin
  optini:=TMemIniFile.Create('option.ini');
  with MainOption do begin
    Fire:=optini.ReadBool('Video','Fire',True);
    FireLight:=optini.ReadBool('Video','FireLight',True);
    Sprite:=optini.ReadBool('Video','Sprite',True);
    Stack:=optini.ReadInteger('Sphere','Stack',32);
    Slice:=optini.ReadInteger('Sphere','Slice',32);
    case optini.ReadInteger('Buffer','AntiAliasing',5) of
      0: AntiAliasing:=aaNone;
      1: AntiAliasing:=aa2x;
      2: AntiAliasing:=aa2xHq;
      3: AntiAliasing:=aa4x;
      4: AntiAliasing:=aa4xHQ;
      5: AntiAliasing:=aaDefault;
    end;
    case optini.ReadInteger('Buffer','ColorDepth',0) of
      0:ColorDepth:=cdDefault;
      1:ColorDepth:=cd8bits;
      2:ColorDepth:=cd16bits;
      3:ColorDepth:=cd24bits;
    end;
    case optini.ReadInteger('Buffer','DepthPrecision',0) of
      0:DepthPrecision:=dpDefault;
      1:DepthPrecision:=dp16bits;
      2:DepthPrecision:=dp24bits;
      3:DepthPrecision:=dp32bits;
    end;
    case optini.ReadInteger('Buffer','SmoothModel',0) of
      0:ShadeModel:=smFlat;
      1:ShadeModel:=smSmooth;
    end;
    DoubleBuffer:=optini.ReadBool('Buffer','DoubleBuffer',True);
    StrencilBuffer:=optini.ReadBool('Buffer','StrencilBuffer',False);
    RenderToWindow:=optini.ReadBool('Buffer','RenderToWindow',True);
    Stereo:=optini.ReadBool('Buffer','Stereo',False);
    DestinationAlpha:=optini.ReadBool('Buffer','DestinationAlpha',False);
    NoColorBuffer:=not optini.ReadBool('Buffer','ColorBuffer',True);
    DepthView:=optini.ReadInteger('Video','DepthView',200);
  end;
end;
end.
